//+---------------------------------------------------------------------+
//|                                            Waddah_Attar_Def_RSI.mq5 |
//|                                 Copyright  2007, Eng. Waddah Attar |
//|                                             waddahattar@hotmail.com |
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property  copyright "Copyright  2007, Eng. Waddah Attar"
#property  link      "waddahattar@hotmail.com"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window 
//----    2
#property indicator_buffers 2 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----      
#property indicator_type1 DRAW_COLOR_HISTOGRAM
//----      
#property indicator_color1 clrDeepPink,clrMagenta,clrGray,clrDodgerBlue,clrOliveDrab
//----   - 
#property indicator_style1 STYLE_SOLID
//----     2
#property indicator_width1 2
//----   
#property indicator_label1 "2pbIdealXOSMA"
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define RESET  0 //        
//+-----------------------------------+
//|    CXMA             |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA1;
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint RSIPeriod1=14; //  RSI
input uint RSIPeriod2=28; //  RSI
input Smooth_Method SmoothMethod=MODE_JJMA; // 
input uint Smooth_XMA=9; // 
input int Smooth_Phase=100;   // ,
                       // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
//+-----------------------------------+
//----      
int min_rates_,min_rates_total;
//----   ,    
//      
double IndBuffer[],ColorIndBuffer[];
//----      
int FRSI_Handle,SRSI_Handle;
//+------------------------------------------------------------------+    
//| Waddah_Attar_Def_RSI indicator initialization function           | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_=int(MathMax(RSIPeriod1,RSIPeriod2));
   min_rates_total=min_rates_+XMA1.GetStartBars(SmoothMethod,Smooth_XMA,Smooth_Phase);
   
//----    iRSI
   FRSI_Handle=iRSI(NULL,0,RSIPeriod1,PRICE_WEIGHTED);
   if(FRSI_Handle==INVALID_HANDLE) Print("      iRSI");
   
//----    iRSI
   SRSI_Handle=iRSI(NULL,0,RSIPeriod2,PRICE_WEIGHTED);
   if(SRSI_Handle==INVALID_HANDLE) Print("      iRSI");

//----    IndBuffer   
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,"Ind");
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
//----       
   ArraySetAsSeries(IndBuffer,true);

//----     ,     
   SetIndexBuffer(1,ColorIndBuffer,INDICATOR_COLOR_INDEX);
//----       
   ArraySetAsSeries(ColorIndBuffer,true);

//----       
   XMA1.XMALengthCheck("Smooth_XMA",Smooth_XMA);
//----       
   XMA1.XMAPhaseCheck("Smooth_Phase",Smooth_Phase,SmoothMethod);

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"Waddah_Attar_Def_RSI");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----  
  }
//+------------------------------------------------------------------+  
//| Waddah_Attar_Def_RSI iteration function                          | 
//+------------------------------------------------------------------+  
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(BarsCalculated(FRSI_Handle)<rates_total
      || BarsCalculated(SRSI_Handle)<rates_total
      || rates_total<min_rates_total)
      return(RESET);

//----    
   int to_copy,limit,bar,maxbar;
   double drsi,FRSI[],SRSI[];
   
   maxbar=rates_total-1-min_rates_;

//----      
//  limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=maxbar; //      
     }
   else
     {
      limit=rates_total-prev_calculated; //      
     }

   to_copy=limit+1;

//----      
   if(CopyBuffer(FRSI_Handle,0,0,to_copy,FRSI)<=0) return(RESET);
   if(CopyBuffer(SRSI_Handle,0,0,to_copy,SRSI)<=0) return(RESET);

//----         
   ArraySetAsSeries(FRSI,true);
   ArraySetAsSeries(SRSI,true);

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      drsi=FRSI[bar]-SRSI[bar];
      IndBuffer[bar]=XMA1.XMASeries(maxbar,prev_calculated,rates_total,SmoothMethod,Smooth_Phase,Smooth_XMA,drsi,bar,true);
     }

   if(prev_calculated>rates_total || prev_calculated<=0) limit--;
//----     Ind
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      ColorIndBuffer[bar]=2;

      if(IndBuffer[bar]>0)
        {
         if(IndBuffer[bar]>IndBuffer[bar+1]) ColorIndBuffer[bar]=4;
         if(IndBuffer[bar]<IndBuffer[bar+1]) ColorIndBuffer[bar]=3;
        }

      if(IndBuffer[bar]<0)
        {
         if(IndBuffer[bar]<IndBuffer[bar+1]) ColorIndBuffer[bar]=0;
         if(IndBuffer[bar]>IndBuffer[bar+1]) ColorIndBuffer[bar]=1;
        }
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
